import unittest, sys
import io
import unittest.mock

from tmc import points

from tmc.utils import load, get_out

main = load('src.main', 'main')

class MainTest(unittest.TestCase):
   
    @points('2-1')
    def test_answer(self):

        higherErrorMessage = "Your count is higher than expected. Is your code counting some additional sequences? (Tip: Check your upper bound and/or constraints)"
        lowerErrorMessage = "Your count is lower than expected. Is your code missing some sequences? (Tip: Check your bounds and/or constraints)."
        hasError = False

        try:
            p0 = 0.1
            I0 = [0.0, 3.0]
            self.assertGreaterEqual(main(p0), I0[0], lowerErrorMessage)
            self.assertLessEqual(main(p0), I0[1], higherErrorMessage)
                        
            p1 = 0.5
            I1 = [247.0, 382.0]
            self.assertGreaterEqual(main(p1), I1[0], lowerErrorMessage)
            self.assertLessEqual(main(p1), I1[1], higherErrorMessage)
                    
            p2 = 1.0
            I2 = [9996.0, 9996.0]
            self.assertGreaterEqual(main(p2), I2[0], lowerErrorMessage)
            self.assertLessEqual(main(p2), I2[1], higherErrorMessage)
        except IndexError:
            hasError = True
            print("IndexError: You are trying to access values outside an array.")
            
        self.assertFalse(hasError, "Encountered an error. Please check your code.")
          
if __name__ == '__main__':
    unittest.main()
